#include <bits/stdc++.h>

using namespace std;
const int N = 1 << 19;
typedef long long ll;

class SegTree
{
	ll tsum[N*2-1], tadd[N*2-1];
public:
	void clear()
	{
		memset(tsum, 0, sizeof(tsum));
		memset(tadd, 0, sizeof(tadd));
	}

	ll getSum(int l, int r, int c = 0, int cl = 0, int cr = N - 1)
	{
		if (l > cr || r < cl)
			return 0;
		if (l <= cl && cr <= r)
			return tsum[c];
		int c1 = c*2 + 1;
		int c2 = c*2 + 2;
		int mid = (cl + cr) / 2;
		tadd[c1] += tadd[c];
		tsum[c1] += tadd[c] * (cr - mid);
		tadd[c2] += tadd[c];
		tsum[c2] += tadd[c] * (cr - mid);
		tadd[c] = 0;
		return getSum(l, r, c1, cl, mid) + getSum(l, r, c2, mid+1, cr);
	}

	void inc(int l, int r, int c = 0, int cl = 0, int cr = N - 1)
	{
		if (l > r)
			return;
		if (l > cr || r < cl)
			return;
		if (l <= cl && cr <= r)
		{
			++tadd[c];
			tsum[c] += cr - cl + 1;
			return;
		}
		int c1 = c*2 + 1;
		int c2 = c*2 + 2;
		int mid = (cl + cr) / 2;
		tadd[c1] += tadd[c];
		tsum[c1] += tadd[c] * (cr - mid);
		tadd[c2] += tadd[c];
		tsum[c2] += tadd[c] * (cr - mid);
		tadd[c] = 0;
		inc(l, r, c1, cl, mid);
		inc(l, r, c2, mid + 1, cr);
		tsum[c] = tsum[c1] + tsum[c2];
	}
} st;

int n;
char s[N];
int p0[N], p1[N];
int m, ql[N], qr[N];
ll qans[N];
vector < int > e[N];

int main()
{
	freopen("numpalindrome.in", "r", stdin);
	freopen("numpalindrome.out", "w", stdout);
	scanf("%d%d", &n, &m);
	scanf("%s", s);

	int r = 0;
	p0[0] = 0;
	for (int i = 1; i < n; ++i)
	{
		if (r + p0[r] > i)
			p0[i] = min(r + p0[r] - i, p0[r - (i-r)]);
		while (i+p0[i] < n && i-1-p0[i] >= 0 && s[i+p0[i]] == s[i-1-p0[i]])
			++p0[i];
		if (i + p0[i] > r + p0[r])
			r = i;
	}
	r = 0;
	p1[0] = 1;
	for (int i = 1; i < n; ++i)
	{
		if (r + p1[r] > i)
			p1[i] = min(r + p1[r] - i, p1[r - (i-r)]);
		while (i+p1[i] < n && i-p1[i] >= 0 && s[i+p1[i]] == s[i-p1[i]])
			++p1[i];
		if (i + p1[i] > r + p1[r])
			r = i;
	}

	for (int i = 0; i < m; ++i)
	{
		scanf("%d%d", &ql[i], &qr[i]);
		--ql[i];
		--qr[i];
		if ((qr[i] - ql[i] + 1) % 2 == 1)
			qans[i] += min(p1[(qr[i]+ql[i])/2], (qr[i]-ql[i])/2+1);
		else
			qans[i] -= min(p0[(qr[i]+ql[i])/2+1], (qr[i]-ql[i]+1)/2);
	}

	for (int i = 0; i < m; ++i)
		if (ql[i] != qr[i])
			e[(ql[i] + qr[i]) / 2 + 1].push_back(i);
	for (int i = n - 1; i >= 0; --i)
	{
		st.inc(i, i + p0[i] - 1);
		st.inc(i, i + p1[i] - 1);
		for (int v : e[i])
			qans[v] += st.getSum(i, qr[v]);
	}

	st.clear();
	for (int i = 0; i < n; ++i)
		e[i].clear();
	for (int i = 0; i < m; ++i)
		if (ql[i] != qr[i])
			e[(ql[i] + qr[i]) / 2 + ((ql[i] + qr[i] + 1) % 2 == 1 ? -1 : 0)].push_back(i);
	for (int i = 0; i < n; ++i)
	{
		st.inc(i - p0[i + 1] + 1, i);
		st.inc(i - p1[i] + 1, i);
		for (int v : e[i])
			qans[v] += st.getSum(ql[v], i);
	}

	for (int i = 0; i < m; ++i)
		printf("%lld\n", qans[i]);
	
	return 0;
}
