from sys import stdin, stderr

MAXN = 100
MAXL = 100
MAXV = 100000

def ensure(x, msg=""):
	if not x:
		print(msg, file=stderr)
		exit(3)
	
def toint(s):
	n = int(s)
	if len(s) > 1 and s[0] == "0":
		raise ValueError()
	return n

ss = stdin.read()
ensure(len(ss) > 0 and ss[-1] == '\n')
ssp = ss[:-1].split('\n')
try:
	n = toint(ssp[0])
except ValueError:
	ensure(False, "n must be an integer, not '%s'" % ssp[0])
ensure(1 <= n <= MAXN, "n must be in [1..%d], but it is %d" % (MAXN, n))
ensure(n == len(ssp) - 1, "number of tests must be exactly n")

for s in ssp[1:]:
	ensure(len(s) != 0, "polynomial must not be empty")
	ensure(len(s) <= MAXL, "polynomial must not be longer then %d symbols" % MAXL)
	ensure(s[0] != "+", "polynomial can't start with '+'")
	if s[0] == '-':
		s = s[1:]
	for o in s.replace("-", "+").split("+"):
		ensure(len(o) != 0, "monomial can't be empty")
		oo = ""
		for c in o:
			if len(oo) != 0 and ((oo[-1] in "0123456789nm" and c in "nm") or (c in "0123456789nm" and oo[-1] in "nm")):
				oo += "*"
			oo += c
		a = 1
		np = 0
		mp = 0
		for w in oo.split("*"):
			ensure(len(w) != 0, "multipler can't be empty")
			if "^" in w:
				ws = w.split('^')
				ensure(len(ws) == 2, "'%s' is a wrong multipler" % w)
				w1, w2 = ws;
				try:
					w2n = toint(w2)
					ensure(w2n <= MAXV, "numbers must not be greater then %d" % MAXV)
				except ValueError:
					ensure(False, "'%s' is a wrong multipler" % w)
				if w1 == "n":
					np += w2n
				elif w1 == "m":
					mp += w2n
				else:
					ensure(False, "'%s' is a wrong multipler" % w)
			else:
				if w == "n":
					np += 1
				elif w == "m":
					mp += 1
				else:
					try:
						wn = toint(w)
						a *= wn
						ensure(wn <= MAXV, "numbers must not be greater then %d" % MAXV)
					except ValueError:
						ensure(False, "'%s' is a wrong multipler" % w)
		ensure(a == 0 or (a <= MAXV and np <= MAXV and mp <= MAXV), "wrong monomial: coefficients are too big (%d*n^%d*m^%d)" % (a, np, mp))
