/**
 * Created by GShark on 29.09.2016.
 */

import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;

public class Check implements Checker {

    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        int cAns1 = ouf.nextInt();
        int cAns2 = -1;
        if (cAns1 != -1)
            cAns2 = ouf.nextInt();
        int jAns1 = ans.nextInt();
        if (jAns1 == -1) {
            return new Outcome(Outcome.Type.FAIL, "Impossible situation");
        } else {
            if (cAns1 == -1) {
                return new Outcome(Outcome.Type.WA, "Contestant doesn't find answer");
            } else {
                cAns1--;
                cAns2--;
                int n = inf.nextInt();
                if (cAns1 < 0 || cAns1 >= n) {
                    return new Outcome(Outcome.Type.WA, "Incorrect first index: " + (cAns1 + 1));
                }
                if (cAns2 < 0 || cAns2 >= n) {
                    return new Outcome(Outcome.Type.WA, "Incorrect second index: " + (cAns2 + 1));
                }
                int a[] = new int[n];
                for (int i = 0; i < n; i++)
                    a[i] = inf.nextInt();
                String s1 = String.valueOf(a[cAns1]);
                String s2 = String.valueOf(a[cAns2]);
                int i = 0, j = s2.length() - 1;
                boolean ok = false;
                while (i < s1.length() && j >= 0) {
                    if (s1.substring(0, i + 1).equals(s2.substring(j, s2.length()))) {
                        ok = true;
                    }
                    i++;
                    j--;
                }
                if (!ok) {
                    return new Outcome(Outcome.Type.WA,
                            String.format("%s(%d) and %s(%d) haven't equals prefix-suffix", s1, cAns1 + 1, s2, cAns2 + 1));
                }
                return new Outcome(Outcome.Type.OK, String.format("%s(%d), %s(%d)", s1, cAns1 + 1, s2, cAns2 + 1));
            }
        }
    }
}
