#include <cstdio>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <algorithm>
#include <sstream>
#include "testlib.h"

using namespace std;

const int MAXN = 1000;
const int MAXX = 1000000000;
int cur_test = -1;

string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(vector<int> test) 
{
    startTest(cur_test++);
    cerr << cur_test << endl;
    cout << test.size() << endl;
    for (int i = 0; i < (int)test.size() - 1; i++)
    {
        printf("%d ", test[i]);
    }
    printf("%d\n", test[test.size() - 1]);
}

void gen_rand(int n, int maxn)
{
    vector<int> a;
    for (int i = 0; i < n; i++)
        a.push_back(rnd.next(maxn) + 1);
    write_test(a);    
}

void gen_rand1(int n, int maxn)
{
    vector<int> a;
    for (int i = 0; i < n; i++)
        a.push_back((rnd.next(maxn) + 1) / 10 * 10);
    write_test(a);    
}

void gen_rand2(int n, int maxn, int f = 1)
{
    vector<int> a;
    if (f)
        a.push_back(1001001);
    for (int i = f; i < n; i++)
        a.push_back((rnd.next(maxn) + 1) / 100 * 100);
    shuffle(a.begin(), a.end());
    write_test(a);    
}



int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);

    for (int i = 10; i <= MAXX; i *= 10)
        gen_rand(min(rnd.next(i) + 1, MAXN), i);
    for (int i = 100; i >= 1; i /= 10)
        gen_rand1(MAXN, MAXX), gen_rand2(MAXN, MAXX);
    gen_rand2(MAXN, MAXX, 0);
    gen_rand(MAXN, MAXX);
    return 0;
}