import random
random.seed("basic01/recovery")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test([93, 31, 23, 31])
        self.print_test([93, 31, 23, 12])
        self.print_test([93, 31, 23, 2])

    def generate_min_tests(self):
        self.print_test([111])
        self.print_test([1111111111111111111])
        self.print_test([198372938173921873921873193871987321])
                                                                    
    def generate_hand_tests(self):
        self.print_test([1, 123])
        self.print_test([239, 239239239217])
        self.print_test([1239, 239239239217])
        self.print_test([1239, 239239239217])
        self.print_test([9283719387193871983798739, 19381793872193879131323325])
        self.print_test([92837193874193871983798739, 19381793872193879131323325])
        self.print_test([93, 83, 81, 91, 113, 123, 191, 1281, 152983])
        self.print_test([23, 41, 1, 34, 21, 42, 232, 422, 4838, 271, 326, 42, 1111])
        self.print_test([92837193874193819873918377198379873135982359948285, 19381793872193879131323325])

    def generate_random_test(self, maxn, maxdiff):
        a = []
        for i in range(maxn):
            add = random.randint(0, maxdiff)
            if len(a) == 0:
                a.append(str(random.randint(0, add)))
            else:
                a.append(str(int(a[-1]) + random.randint(0, add)))
            a[-1] = a[-1].replace('0', '1')
        operations = random.randint(len(a), len(a) * 5)
        for i in range(operations):
            index = random.randint(0, len(a) - 1)
            sa = str(a[index])
            pos = random.randint(0, len(sa) - 1)
            newnum = sa[:pos] + str(random.randint(1, 9)) + sa[pos:]
            while newnum[0] == '0':
                newnum = sa[:pos] + str(random.randint(1, 9)) + sa[pos:]
            a[index] = int(newnum)
        self.print_test(a)

    def generate_max_tests(self, maxn):
        n = 100
        a = []
        for i in range(n):
            s = ''
            s += chr(random.randint(1, 9) + ord('0'))
            for j in range(999):
                s += chr(random.randint(1, 9) + ord('0'))
            a.append(int(s))
        self.print_test(a)

        self.print_test(['1' * 50000, ('1' * 49999) + '2'])
        b = list(('1' * 49999) + '2')
        random.shuffle(b)
        self.print_test(['1' * 50000, ''.join(b)])

        n = 100
        for it in range(3):
            a = []
            for i in range(n):
                length = 1000
                s = ''
                for j in range(length):
                    s += '8' if random.randint(1, 2) == 1 else '9'
                a.append(s)
            self.print_test(a)
        for it in range(2):
            a = []
            for i in range(n):
                length = 1000
                ones = random.randint(1, 10)
                s = ['1' for i in range(length)]
                for j in range(ones):
                    index = random.randint(0, len(s) - 1)
                    s[index] = '2'
                a.append(''.join(s))
            self.print_test(a)
            a = []
            n = random.randint(2, 4)
            for i in range(n):
                length = 10**5 // n
                ones = random.randint(1, 10)
                d1 = '1'
                d2 = '2'
                if it == 1:
                    d1 = '8'
                    d2 = '9'
                s = [d1 for i in range(length)]
                for j in range(ones):
                    index = random.randint(0, len(s) - 1)
                    s[index] = d2
                a.append(''.join(s))
            self.print_test(a)
        n = 2
        length = 50000 - random.randint(1, 1000)
        a = ['1' for i in range(length)]
        b = ['1' for i in range(10**5 - length)]
        ops = random.randint(1, 10)
        for i in range(ops):
            index = random.randint(0, len(a) - 1)
            a[index] = '2'
            index = random.randint(0, len(b) - 1)
            b[index] = '2'
        self.print_test([''.join(a), ''.join(b)])
        n = 2
        length = 50000 - random.randint(1, 1000)
        a = ['8' for i in range(length)]
        b = ['8' for i in range(10**5 - length)]
        ops = random.randint(1, 5)
        for i in range(ops):
            index = random.randint(0, len(a) - 1)
            a[index] = '9'
            index = random.randint(0, len(b) - 1)
            b[index] = '9'
        self.print_test([''.join(a), ''.join(b)])

    def print_test(self, elements):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(len(elements), file=test_file)
        print('\n'.join(str(element) for element in elements), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        ns = [5, 10, 25, 50, 100]
        diffs = [100, 10**10, 10**50, 10**100, 10**900]
        for n in ns:
            for diff in diffs:
                self.generate_random_test(n, diff)
        self.generate_max_tests(1000)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
