#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <cstdio>
using namespace std;

const int N = 1e5 + 10;
#define TASK "recovery"

string getMaxLessOrEqual(const string& a, const string& b) {
    int n = a.size();
    int m = b.size();
    vector<vector<int> > prev(n + 1, vector<int>(10, n));
    for (int i = n - 1; i >= 0; --i) {
        prev[i] = prev[i + 1];
        prev[i][a[i] - '0'] = i;
    }

    int mxl = -1, mxdig, pos;
    int i = -1;
    for (int l = 0; l < m && i < n; ++l) {
        for (int dig = int(b[l] - '0') - 1; dig >= 0; --dig) {
            if (n - prev[i + 1][dig] >= m - l) {
                mxl = l;
                mxdig = dig;
                pos = prev[i + 1][dig] + 1;
                break;
            }
        }
        ++i;
        for (; i < n && b[l] != a[i]; ++i);
    }

    if (i != n) {
        return b;
    }

    string ans;
    if (mxl != -1) {
        ans = b.substr(0, mxl) + char('0' + mxdig);
        m -= mxl + 1;
    } else {
        pos = 0;
        m = min(m - 1, n);
    }
    for (int c = 0; c < m; ++c) {
        for (int dig = 9; dig >= 0; --dig) {
            if (n - prev[pos][dig] >= m - c) {
                ans += char('0' + dig);
                pos = prev[pos][dig] + 1;
                break;
            }
        }
    }
    return ans;
}

char ss[N];
int main() {
    freopen(TASK".in", "r", stdin);
    freopen(TASK".out", "w", stdout);
    int n;
    cin >> n;
    vector<string> a(n);
    for (int i = 0; i < n; ++i) {
        scanf("%s", ss);
        a[i] = ss;
    }
    string prevNumber = a[n - 1];
    int deleted = 0;
    for (int i = n - 2; i >= 0; --i) {
        prevNumber = getMaxLessOrEqual(a[i], prevNumber);
        if (prevNumber.size() == 0) {
            cout << "-1" << endl;
            return 0;
        }
        deleted += (int)a[i].size() - prevNumber.size();
    }
    cout << deleted << endl;
    return 0;
}
