#include <sstream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <string>
#include <cassert>
#include <ctime>
#include <map>
#include <math.h>
#include <cstdio>
#include <set>
#include <deque>
#include <memory.h>
#include <queue>

using namespace std;

int main() {
	freopen("recovery.in", "r", stdin);
	freopen("recovery.out", "w", stdout);

	int n;
	while (cin >> n) {
		vector<string> a(n);
		for (int i = 0; i < n; i++) cin >> a[i];

		string last = "";
		for (int i = 0; i <= (int)a[n - 1].length(); i++) last += "9";

		int ans = 0;
		for (int i = n - 1; i >= 0; i--) {
			if (a[i].length() < last.length()) {
				last = a[i];
				continue;
			}
			int k = a[i].length();

			auto getNxt = [&](const string &s) {
				int n = s.length();
				vector<vector<int> > nxt(n + 1, vector<int>(10, n));
				for (int j = n - 1; j >= 0; j--) {
					nxt[j] = nxt[j + 1];
					nxt[j][s[j] - '0'] = j;
				}
				return nxt;
			};

			vector<vector<int> > nxt = getNxt(a[i]);
			
			int l = -1, r = (int)last.length() + 1;
			while (r - l > 1) {
				int m = (l + r) / 2;
				
				int x = -1;
				for (int j = 0; j < m && x < k; j++) x = nxt[x + 1][last[j] - '0'];

				if (x == k) {
					r = m;
					continue;
				}
				bool ok = 0;
				for (int neq = m; x < k && neq < (int)last.length(); neq++) {
					for (int c = 0; c < last[neq] - '0'; c++) {
						ok |= k - nxt[x + 1][c] >= (int)last.length() - neq;
					}
					x = nxt[x + 1][last[neq] - '0'];
				}
				ok |= x != k;

				if (ok) l = m;
				else r = m;
			}

			int len, eq;
			if (l == -1) {
				len = (int)last.length() - 1;
				eq = 0;
			}
			else {
				len = (int)last.length(); 
				eq = l;
			}

			if (len == 0) {
				ans = -1;
				break;
			}
			ans += (int)a[i].length() - len;

			string nlast = "";
			int x = -1;
			bool less = len != (int)last.length();
			for (int j = 0; j < eq; j++) {
				nlast += a[i][nxt[x + 1][last[j] - '0']];
				x = nxt[x + 1][last[j] - '0'];
			}
			while ((int)nlast.length() < len) {
				for (int c = 9; c >= 0; c--) {
					if ((less || c < last[(int)nlast.length()] - '0') && k - nxt[x + 1][c] >= len - (int)nlast.length()) {
						less |= c < last[(int)nlast.length()];
						nlast += a[i][nxt[x + 1][c]];
						x = nxt[x + 1][c];
						break;
					}
				}
			}
			last = nlast;
		}
		cout << ans << endl;
	}

	return 0;
}
