#include "bits/stdc++.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXN = 1e6, bd = 20;

int binup[bd][MAXN];
vector<int> graph[MAXN];
int depth[MAXN];

int dfs(int v, int p, int d) {
    depth[v] = d;
    binup[0][v] = p;
    for (int i = 1; i < bd; ++i) {
        binup[i][v] = binup[i - 1][binup[i - 1][v]];
    }

    for (int to: graph[v]) {
        if (to != p) {
            dfs(to, v, d + 1);
        }
    }
    return 0;
}

int get_lca(int a, int b) {
    if (depth[a] < depth[b]) {
        swap(a, b);
    }
    for (int i = bd - 1; i >= 0; --i) {
        if (depth[a] - (1 << i) >= depth[b]) {
            a = binup[i][a];
        }
    }
    if (a == b) {
        return a;
    }
    for (int i = bd - 1; i >= 0; --i) {
        if (binup[i][a] != binup[i][b]) {
            a = binup[i][a];
            b = binup[i][b];
        }
    }
    return binup[0][a];
}

int up_for(int v, int l) {
    for (int i = bd - 1; i >= 0; --i) {
        if (l >= (1 << i)) {
            l -= (1 << i);
            v = binup[i][v];
        }
    }
    return v;
}

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    freopen("treefirstedge.in", "r", stdin);
    freopen("treefirstedge.out", "w", stdout);

    int n;
    scanf("%d", &n);

    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        scanf("%d%d", &a, &b);
        --a; --b;
        graph[a].puba(b);
        graph[b].puba(a);
    }

    dfs(0, 0, 0);

    int q;
    scanf("%d", &q);

    for (int i = 0; i < q; ++i) {
        int a, b;
        scanf("%d%d", &a, &b);
        --a; --b;
        int lca = get_lca(a, b);
        if (depth[lca] < depth[a]) {
            cout << binup[0][a] + 1 << "\n";
        } else {
            cout << up_for(b, depth[b] - depth[a] - 1) + 1 << "\n";
        }
    }


    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}