import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.StringTokenizer;

public class treefirstedge_iz {
    Scanner in;
    PrintWriter out;

    int n;
    ArrayList<Integer> e[];
    int tin[], tout[], tmr;
    int p[];

    void dfs(int v, int pr) {
        e[v].remove(Integer.valueOf(pr));
        p[v] = pr;
        tin[v] = ++tmr;
        for (int i = 0; i < e[v].size(); i++) {
            int to = e[v].get(i);
            if (tin[to] == 0) {
                dfs(to, v);
            }
        }
        tout[v] = ++tmr;
    }

    private void solve() {
        n = in.nextInt();
        e = new ArrayList[n];
        for (int i = 0; i < n; i++) e[i] = new ArrayList<>();
        for (int i = 0; i < n - 1; i++) {
            int u = in.nextInt() - 1;
            int v = in.nextInt() - 1;
            e[u].add(v);
            e[v].add(u);
        }
        tin = new int[n];
        tout = new int[n];
        p = new int[n];
        dfs(0, -1);
        for (int i = 0; i < n; i++) {
            Collections.sort(e[i], (o1, o2) -> Integer.compare(tin[o1], tin[o2]));
        }
        int q = in.nextInt();
        for (int i = 0; i < q; i++) {
            int u = in.nextInt() - 1;
            int v = in.nextInt() - 1;
            if (tin[u] <= tin[v] && tout[v] <= tout[u]) {
                int L = -1, R = e[u].size();
                while (R - L > 1) {
                    int M = (L + R) / 2;
                    if (tin[e[u].get(M)] <= tin[v]) {
                        L = M;
                    } else {
                        R = M;
                    }
                }
                out.println(e[u].get(L) + 1);
            } else {
                out.println(p[u] + 1);
            }
        }
    }

    private void run() {
        try {
            in = new Scanner(new File("treefirstedge.in"));
            out = new PrintWriter(new File("treefirstedge.out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        new treefirstedge_iz().run();
    }

    class Scanner {
        BufferedReader br;
        StringTokenizer st;

        Scanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

}
